/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.datamaps;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.util.ArrayList;
import java.util.List;
import javax.swing.JPanel;
import org.apache.log4j.Logger;
import org.visnow.vn.gui.swingwrappers.UserActionListener;

/**
 * Viewer/Editor for custom numeric correction for RGB color tables (float number [-1, 1]).
 * Viewer just shows RGBColorTable.
 * Editor gives editing capabilities of floating number [-1, 1]:
 * - change value on dragging left/right
 * - reset to 0 on click
 * <p>
 * There is no internal update of view of this control. You need to manually call updateView() every time it's necessary.
 * <p>
 * This editor uses userAction to communicate user actions. There is currently no support for userChangeAction. No action on setters.
 * <p>
 * @author Krzysztof S. Nowinski, University of Warsaw ICM
 * @author szpak
 */
public class RGBCorrectionEditor extends JPanel
{
    private static final Logger LOGGER = Logger.getLogger(RGBCorrectionEditor.class);

//    protected CustomizableColorMap map = new CustomizableColorMap();
    private BufferedImage img;
    private float correctionValue = 0;
    private float correctionValueDragStart = 0;
    private int dragStartX = 0;
    private int w = 256;
    private int h = 14;
    private int[] dpix = new int[w * h];
    private boolean adjusting = false;

    /**
     * Creates new form ColorEditor
     */
    public RGBCorrectionEditor()
    {
        initComponents();
        setBackground(Color.LIGHT_GRAY);
        updateView(new int[]{0});
    }

    /**
     * @param rgbColorTable non-empty list of colors formatted as BufferedImage.TYPE_INT_ARGB
     */
    public void updateView(int[] rgbColorTable)
    {
        if (rgbColorTable.length == 0) {
            LOGGER.error("Color table cannot be empty!");
            throw new IllegalArgumentException("Color table cannot be empty!");
        }

        img = new BufferedImage(w, h, BufferedImage.TYPE_INT_ARGB);
//        int[] colorMapLookup = map.getRGBColorTable();
        float d = rgbColorTable.length / (float) w;
        for (int i = 0; i < w; i++) {
            int k = rgbColorTable[(int) (d * i)];
            for (int j = 0; j < h; j++)
                dpix[i + j * w] = k;
        }
        img.setRGB(0, 0, w, h, dpix, 0, w);
        repaint();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        colorDialog = new javax.swing.JFrame();
        jPanel2 = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();

        colorDialog.setBackground(new java.awt.Color(134, 147, 156));
        colorDialog.setBounds(new java.awt.Rectangle(200, 200, 254, 154));
        colorDialog.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        colorDialog.setName("colorDialog"); // NOI18N
        colorDialog.setResizable(false);
        colorDialog.setUndecorated(true);

        jPanel2.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel2.setName("jPanel2"); // NOI18N
        jPanel2.setLayout(new java.awt.GridBagLayout());

        jPanel1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel1.setMinimumSize(new java.awt.Dimension(252, 152));
        jPanel1.setName("jPanel1"); // NOI18N
        jPanel1.setPreferredSize(new java.awt.Dimension(252, 152));
        jPanel1.setLayout(new java.awt.BorderLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 3, 0);
        jPanel2.add(jPanel1, gridBagConstraints);

        colorDialog.getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        setToolTipText("<html>drag LMB to darken/brighten<p>click to reset</html>");
        setMinimumSize(new java.awt.Dimension(50, 21));
        setPreferredSize(new java.awt.Dimension(50, 21));
        addMouseListener(new java.awt.event.MouseAdapter()
        {
            public void mouseClicked(java.awt.event.MouseEvent evt)
            {
                formMouseClicked(evt);
            }
            public void mousePressed(java.awt.event.MouseEvent evt)
            {
                formMousePressed(evt);
            }
            public void mouseReleased(java.awt.event.MouseEvent evt)
            {
                formMouseReleased(evt);
            }
        });
        addMouseMotionListener(new java.awt.event.MouseMotionAdapter()
        {
            public void mouseDragged(java.awt.event.MouseEvent evt)
            {
                formMouseDragged(evt);
            }
        });
        setLayout(null);
    }// </editor-fold>//GEN-END:initComponents

    @Override
    public void paint(Graphics g)
    {
        int ww = getWidth();
        int wh = getHeight();
        g.setColor(Color.LIGHT_GRAY);
        g.fillRect(0, 0, ww, wh);
        if (this.isEnabled())
            g.drawImage(img, 3, 3, ww - 6, wh - 6, null);
    }

    private void formMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMouseClicked
        correctionValue = 0;
        fireUserAction();
    }//GEN-LAST:event_formMouseClicked

    private void formMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMousePressed
        adjusting = true;
        dragStartX = evt.getX();
        correctionValueDragStart = correctionValue;
    }//GEN-LAST:event_formMousePressed

    private void formMouseDragged(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMouseDragged
        adjusting = true;
        correctionValue = Math.max(-1.0f, Math.min(1.0f, correctionValueDragStart + (evt.getX() - dragStartX) / 200.0f));
        fireUserAction();
    }//GEN-LAST:event_formMouseDragged

    private void formMouseReleased(java.awt.event.MouseEvent evt)//GEN-FIRST:event_formMouseReleased
    {//GEN-HEADEREND:event_formMouseReleased
        adjusting = false;
        fireUserAction();
    }//GEN-LAST:event_formMouseReleased
    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected javax.swing.JFrame colorDialog;
    protected javax.swing.JPanel jPanel1;
    protected javax.swing.JPanel jPanel2;
    // End of variables declaration//GEN-END:variables
    public boolean isAdjusting()
    {
        return adjusting;
    }

    public float getValue()
    {
        return correctionValue;
    }
    
    public void setValue(float value)
    {
        correctionValue = value;
    }
    
    /**
     * Notifies all UserActionListeners about userAction.
     */
    private void fireUserAction()
    {
        for (UserActionListener listener : userActionListeners)
            listener.userAction(new org.visnow.vn.gui.swingwrappers.UserEvent(this));
    }

    private List<UserActionListener> userActionListeners = new ArrayList<UserActionListener>();

    public void addUserActionListener(UserActionListener listener)
    {
        userActionListeners.add(listener);
    }

    public void removeUserActionListener(UserActionListener listener)
    {
        userActionListeners.remove(listener);
    }
}
